rm -rf sv
mkdir -p sv

if [ ! -d "opentitan" ] ; then
	git clone https://github.com/lowRISC/opentitan.git
  
  # README: If you are looking for the autogenerated primitives, then run opentitan as follows and copy the files to the top hierachy of this aes folder
  # fusesoc --cores-root . run --flag=fileset_top --target=sim --setup --build lowrisc:systems:top_earlgrey_verilator
  # cp build/lowrisc_systems_top_earlgrey_verilator_0.1/sim-verilator/generated/lowrisc_prim_buf-impl_0/prim_buf.sv ../
  # cp opentitan/build/lowrisc_systems_top_earlgrey_verilator_0.1/sim-verilator/generated/lowrisc_prim_flop_2sync-impl_0/prim_flop_2sync.sv ../
  # cp opentitan/build/lowrisc_systems_top_earlgrey_verilator_0.1/sim-verilator/generated/lowrisc_prim_flop-impl_0/prim_flop.sv ../
fi

# the top package verilog contains some required constants (ie bus width)
cp opentitan/hw/top_earlgrey/rtl/top_pkg.sv sv/

# copy required IP RTL
cp opentitan/hw/ip/aes/rtl/* sv/
cp opentitan/hw/ip/tlul/rtl/* sv/
cp opentitan/hw/ip/prim/rtl/* sv/

# autogenerated primitives (see above if you want to make your own)
cp prim_buf.sv sv/
cp opentitan/hw/ip/prim_generic/rtl/prim_generic_buf.sv sv/
cp prim_flop.sv sv/
cp opentitan/hw/ip/prim_generic/rtl/prim_generic_flop.sv sv/
cp prim_flop_2sync.sv sv/
cp opentitan/hw/ip/prim_generic/rtl/prim_generic_flop_2sync.sv sv/

# these cause a LOT of dependencies to show up, and they are not required for AES
rm sv/prim_lc_sync.sv
rm sv/prim_lc_sender.sv
rm sv/prim_edn_req.sv
rm sv/prim_lc_dec.sv

# Fix utf8 sv2v doesn't get
cat sv/prim_keccak.sv | iconv -f utf-8 -t ascii//TRANSLIT -o sv/prim_keccak.sv

cp aes_sim.sv sv/

sv2v -DSYNTHESIS sv/*.sv +RTS -N4 > verilog.v

# TODO: map to a different cell library, using the default standard cell library for now
yosys -QTqp "
  read_verilog verilog.v;
  hierarchy -check -top aes_sim;
  synth
  write_verilog netlist.v
"
